# This file was created automatically by SWIG.
import permittivityc
from ooflib.SWIG.engine.properties import PropertyPtr
from ooflib.SWIG.engine.symmmatrix import SymmMatrixPtr
class IsoDielectricPermittivityPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsoDielectricPermittivity instance at %s>" % (self.this,)
class IsoDielectricPermittivity(IsoDielectricPermittivityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(permittivityc.new_IsoDielectricPermittivity,_args,_kwargs)
        self.thisown = 1




class AnisoDielectricPermittivityPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C AnisoDielectricPermittivity instance at %s>" % (self.this,)
class AnisoDielectricPermittivity(AnisoDielectricPermittivityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(permittivityc.new_AnisoDielectricPermittivity,_args,_kwargs)
        self.thisown = 1




class ChargeDensityPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def rho(self, *_args, **_kwargs):
        val = apply(permittivityc.ChargeDensity_rho,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ChargeDensity instance at %s>" % (self.this,)
class ChargeDensity(ChargeDensityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(permittivityc.new_ChargeDensity,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: permittivity.spy,v $
# $Revision: 1.4 $
# $Author: vrc $
# $Date: 2007-09-26 22:03:23 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

PropertyRegistration = propertyregistration.PropertyRegistration

dielectricConductivity = PropertyRegistration(
    'Electric:DielectricPermittivity:Isotropic',
    IsoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",
    ordering=98,
    params=[parameter.FloatParameter('epsilon',
                                     1.0, tip=parameter.emptyTipString)],
    fields=[problem.Voltage],
    fluxes=[problem.Total_Polarization],
    outputs=["Energy"],
    propertyType="DielectricPermittivity",
    tip="Isotropic dielectric permittivity."
    )

## TRICLINIC

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Triclinic',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",105,
    [symmmatrix.TriclinicRank2TensorParameter(
    'epsilon',
    symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Triclinic dielectric permittivity")

## MONOCLINIC

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Monoclinic',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",104,
    [symmmatrix.MonoclinicRank2TensorParameter(
    'epsilon',
    symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Monoclinic dielectric permittivity.")

## ORTHORHOMBIC

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Orthorhombic',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",103,
    [symmmatrix.OrthorhombicRank2TensorParameter(
    'epsilon',
    symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Orthorhombic dielectric permittivity.")

## TETRAGONAL

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Tetragonal',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",101,
    [symmmatrix.TetragonalRank2TensorParameter(
    'epsilon',
    symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=1.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Tetragonal dielectric permittivity.")

## TRIGONAL

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Trigonal',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",102,
    [symmmatrix.TrigonalRank2TensorParameter(
    'epsilon',
    symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Trigonal dielectric permittivity")

## HEXAGONAL

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Hexagonal',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",100,
    [symmmatrix.HexagonalRank2TensorParameter(
    'epsilon',
    symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Hexagonal dielectric permittivity")


## CUBIC

PropertyRegistration(
    'Electric:DielectricPermittivity:Anisotropic:Cubic',
    AnisoDielectricPermittivity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",99,
    [symmmatrix.CubicRank2TensorParameter(
    'epsilon',
    symmmatrix.CubicRank2Tensor(xx=1.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Voltage], fluxes=[problem.Total_Polarization],
    propertyType="DielectricPermittivity",
    tip="Cubic dielectric permittivity")


## *Electric* BODY forces (sorry Andrew... --REG)

PropertyRegistration(
    'Electric:SpaceCharge', ChargeDensity,
    "ooflib.SWIG.engine.property.permittivity.permittivity",150,
    [parameter.FloatParameter('charge', 0.0, tip="electrostatic charge density")],
    fluxes=[problem.Total_Polarization],
    propertyType="ChargeDensity",
    tip="Spatial charge density")

